
{  This is a small utility I wrote some time back when I needed a copy
   of my BIOS ROM to try a few things.  You may use it, modify it, and/or
   give it away to whom ever you can get to take it with no restrictions
   what so ever as far as I'm concerned.  I will accept no responsibility
   for any damages, copyright infringements, or loss of use or savings that
   may result from the use of this program or concepts presented here, in
   other words, you are on your own and use it at your own risk.  It is
   a crime to copy and distribute copyrighted BIOS ROMS.

                        Bill Holland
                        217 St. Joe Rd. E.
                        Sellersburg, In.  47172

                        Short Circuit BBS
                        812-246-9293

   Turbo Pascal 5.0
   This program is not a commercial program and probably can be much improved
   upon by about anyone who wishes to put forth a little effort.  It does no
   checking to see if you have the ROM sizes correct or anything else.  It
   will run on an XT but the files produced are useless.  Three files are
   produced when the program is run, they are BIO.ROM, BIO.LO, and BIO.HI.
   BIO.ROM is a 32K or 64K file with an image of the BIOS area of memory.
   BIO.LO is a 16K or 32K file with the low or even half of the BIOS area.
   BIO.HI is a 16K or 32K file with the high or odd half of the BIOS area.

   If any one produces a nice and improved version of this program, I would
   appreciate a copy of it.

}

{$A+}    {Align memory words}
{$R-}    {Range checking off}
{$B-}    {Boolean complete evaluation off}
{$S-}    {Stack checking off}
{$I-}    {I/O checking off}
{$V-)    {String checking off}
{$N-}    {No numeric coprocessor}
{$M 16384,32768,65535} { stack and heap}

PROGRAM ATRom;

USES
  DOS, CRT;


Var
  Low    : Array[0..$7FFF] of Byte Absolute $F000:0000;
  High   : Array[0..$7FFF] of Byte Absolute $F000:$8000;

  New    : Array[0..$7FFF] of Byte;

  OutFile: File;
  LoFile : File;
  HiFile : File;
  x,y    : Word;
  Cin    : Char;
  Blocks : Word;


Procedure  Get_ROM;
Begin
  If  Cin = '2'  Then  Writeln(' 64K ROM')  else  Writeln(' 32K ROM');
  Writeln(' Saving BIO.ROM');
  Assign( OutFile, 'BIO.ROM' );
  Rewrite( OutFile );
  If  Cin = '2'  Then  BlockWrite( OutFile, Low, 256 );
  BlockWrite( OutFile, High, 256 );
  Close( OutFile );
end;

Procedure  Get_Lo;
Begin
  Writeln(' Saving BIO.LO');
  x := 0;
  y := 0;
  Blocks := 128;
  If  Cin = '2'  Then  Begin
    Blocks := 256;
    While  x < $8000  Do  Begin
      New[ y ] := Low[ x ];
      inc( y );
      inc( x, 2 );
    End;
  End;
  x := 0;
  While  x < $8000  Do  Begin
    New[ y ] := High[ x ];
    inc( y );
    inc( x, 2 );
  End;
  Assign( OutFile, 'BIO.LO' );
  ReWrite( OutFile );
  BlockWrite( OutFile, New, Blocks );
  Close( OutFile );
end;

Procedure  Get_Hi;
Begin
  Writeln(' Saving BIO.HI');
  x := 1;
  y := 0;
  Blocks := 128;
  If  Cin = '2'  Then  Begin
    Blocks := 256;
    While  x < $8000  Do  Begin
      New[ y ] := Low[ x ];
      inc( y );
      inc( x, 2 );
    End;
  end;
  x := 1;
  While  x < $8000  Do  Begin
    New[ y ] := High[ x ];
    inc( y );
    inc( x, 2 );
  End;
  Assign( OutFile, 'BIO.HI' );
  ReWrite( OutFile );
  BlockWrite( OutFile, New, Blocks );
  Close( OutFile );
end;

Procedure  Get_BIOS;
Begin
  Get_ROM;
  Get_Lo;
  Get_Hi;
End;


Begin
  Writeln;
  Writeln('    Select BIOS ROM Size' );
  Writeln;
  Writeln('      1 - 32K BIOS');
  Writeln('      2 - 64K BIOS');
  Writeln('  Press [ESC] to cancel');
    Writeln;
  repeat
    Write(' Select BIOS Size (1,2, or [ESC]) -> ');
    Cin := ReadKey;
    If  Cin in[' '..'z']  Then  writeLn( Cin )  else  Writeln;
  until  Cin in['1','2',#$1B];
  If  NOT (Cin = #$1B)  Then  Get_BIOS else writeln('  CANCELED');
END.


